diff --git a/xen/arch/x86/apic.c b/xen/arch/x86/apic.c
index 8f192f80b852..8e8ff4d155ff 100644
--- a/xen/arch/x86/apic.c
+++ b/xen/arch/x86/apic.c
@@ -26,6 +26,8 @@
 #include <xen/delay.h>
 #include <xen/smp.h>
 #include <xen/softirq.h>
+
+#include <asm/irq-vectors.h>
 #include <asm/mc146818rtc.h>
 #include <asm/microcode.h>
 #include <asm/msr.h>
@@ -38,7 +40,6 @@
 #include <asm/genapic.h>
 
 #include <io_ports.h>
-#include <irq_vectors.h>
 #include <xen/kexec.h>
 #include <asm/guest.h>
 #include <asm/nmi.h>
diff --git a/xen/arch/x86/cpu/vpmu.c b/xen/arch/x86/cpu/vpmu.c
index a5bb1689c7d5..c28192ea2662 100644
--- a/xen/arch/x86/cpu/vpmu.c
+++ b/xen/arch/x86/cpu/vpmu.c
@@ -13,13 +13,15 @@
 #include <xen/guest_access.h>
 #include <xen/hypercall.h>
 #include <xen/sched.h>
+
+#include <asm/irq-vectors.h>
 #include <asm/regs.h>
 #include <asm/msr.h>
 #include <asm/nmi.h>
 #include <asm/p2m.h>
 #include <asm/vpmu.h>
 #include <asm/apic.h>
-#include <irq_vectors.h>
+
 #include <public/pmu.h>
 #include <xsm/xsm.h>
 
diff --git a/xen/arch/x86/i8259.c b/xen/arch/x86/i8259.c
index 10ddd2b0fbbf..a14f20bdf676 100644
--- a/xen/arch/x86/i8259.c
+++ b/xen/arch/x86/i8259.c
@@ -19,9 +19,9 @@
 #include <xen/delay.h>
 #include <asm/apic.h>
 #include <asm/asm_defns.h>
+#include <asm/irq-vectors.h>
 #include <asm/setup.h>
 #include <io_ports.h>
-#include <irq_vectors.h>
 
 /*
  * This is the 'legacy' 8259A Programmable Interrupt Controller,
diff --git a/xen/arch/x86/include/asm/mach-default/irq_vectors.h b/xen/arch/x86/include/asm/irq-vectors.h
similarity index 100%
rename from xen/arch/x86/include/asm/mach-default/irq_vectors.h
rename to xen/arch/x86/include/asm/irq-vectors.h
diff --git a/xen/arch/x86/io_apic.c b/xen/arch/x86/io_apic.c
index 13daebc10a97..12cc4a561d14 100644
--- a/xen/arch/x86/io_apic.c
+++ b/xen/arch/x86/io_apic.c
@@ -35,6 +35,7 @@
 #include <asm/genapic.h>
 #include <asm/hpet.h>
 #include <asm/io_apic.h>
+#include <asm/irq-vectors.h>
 #include <asm/mc146818rtc.h>
 #include <asm/smp.h>
 #include <asm/desc.h>
@@ -42,7 +43,6 @@
 #include <asm/setup.h>
 
 #include <io_ports.h>
-#include <irq_vectors.h>
 #include <public/physdev.h>
 #include <xen/trace.h>
 
diff --git a/xen/arch/x86/irq.c b/xen/arch/x86/irq.c
index 6340cd6dd73d..e56bacc88d84 100644
--- a/xen/arch/x86/irq.c
+++ b/xen/arch/x86/irq.c
@@ -25,11 +25,11 @@
 #include <asm/apic.h>
 #include <asm/genapic.h>
 #include <asm/io_apic.h>
+#include <asm/irq-vectors.h>
 #include <asm/msi.h>
 #include <asm/current.h>
 #include <asm/flushtlb.h>
 
-#include <irq_vectors.h>
 #include <public/physdev.h>
 
 /* opt_noirqbalance: If true, software IRQ balancing/affinity is disabled. */
diff --git a/xen/arch/x86/msi.c b/xen/arch/x86/msi.c
index 68d6e25178a9..be5ef99e088f 100644
--- a/xen/arch/x86/msi.c
+++ b/xen/arch/x86/msi.c
@@ -26,6 +26,7 @@
 #include <asm/genapic.h>
 #include <asm/io.h>
 #include <asm/io_apic.h>
+#include <asm/irq-vectors.h>
 #include <asm/smp.h>
 #include <asm/desc.h>
 #include <asm/msi.h>
@@ -33,7 +34,6 @@
 #include <asm/p2m.h>
 
 #include <io_ports.h>
-#include <irq_vectors.h>
 #include <public/physdev.h>
 #include <xen/iommu.h>
 #include <xsm/xsm.h>
diff --git a/xen/arch/x86/pv/hypercall.c b/xen/arch/x86/pv/hypercall.c
index 4294e930128b..2febade44b73 100644
--- a/xen/arch/x86/pv/hypercall.c
+++ b/xen/arch/x86/pv/hypercall.c
@@ -11,9 +11,10 @@
 #include <xen/hypercall.h>
 #include <xen/nospec.h>
 #include <xen/trace.h>
+
 #include <asm/apic.h>
+#include <asm/irq-vectors.h>
 #include <asm/multicall.h>
-#include <irq_vectors.h>
 
 /* Forced inline to cause 'compat' to be evaluated at compile time. */
 static void always_inline
diff --git a/xen/arch/x86/pv/traps.c b/xen/arch/x86/pv/traps.c
index ed8aa97382b7..fd1597d0bdea 100644
--- a/xen/arch/x86/pv/traps.c
+++ b/xen/arch/x86/pv/traps.c
@@ -13,10 +13,10 @@
 #include <xen/softirq.h>
 
 #include <asm/debugreg.h>
+#include <asm/irq-vectors.h>
 #include <asm/pv/trace.h>
 #include <asm/shared.h>
 #include <asm/traps.h>
-#include <irq_vectors.h>
 
 void pv_inject_event(const struct x86_event *event)
 {
diff --git a/xen/arch/x86/smp.c b/xen/arch/x86/smp.c
index bd337e548c5a..02a6ed7593f3 100644
--- a/xen/arch/x86/smp.c
+++ b/xen/arch/x86/smp.c
@@ -19,13 +19,13 @@
 #include <asm/current.h>
 #include <asm/genapic.h>
 #include <asm/guest.h>
+#include <asm/irq-vectors.h>
 #include <asm/smp.h>
 #include <asm/mc146818rtc.h>
 #include <asm/flushtlb.h>
 #include <asm/hardirq.h>
 #include <asm/hpet.h>
 #include <asm/setup.h>
-#include <irq_vectors.h>
 
 /* Helper functions to prepare APIC register values. */
 static unsigned int prepare_ICR(unsigned int shortcut, int vector)
diff --git a/xen/arch/x86/smpboot.c b/xen/arch/x86/smpboot.c
index 42272a9844fa..568a3abe1f47 100644
--- a/xen/arch/x86/smpboot.c
+++ b/xen/arch/x86/smpboot.c
@@ -39,7 +39,7 @@
 #include <asm/time.h>
 #include <asm/tboot.h>
 #include <asm/trampoline.h>
-#include <irq_vectors.h>
+#include <asm/irq-vectors.h>
 
 unsigned long __read_mostly trampoline_phys;
 enum ap_boot_method __read_mostly ap_boot_method = AP_BOOT_NORMAL;
diff --git a/xen/arch/x86/traps.c b/xen/arch/x86/traps.c
index a9c2c607eb08..fd8a4448e3f7 100644
--- a/xen/arch/x86/traps.c
+++ b/xen/arch/x86/traps.c
@@ -69,7 +69,7 @@
 #include <public/hvm/params.h>
 #include <asm/cpuid.h>
 #include <xsm/xsm.h>
-#include <asm/mach-default/irq_vectors.h>
+#include <asm/irq-vectors.h>
 #include <asm/pv/traps.h>
 #include <asm/pv/trace.h>
 #include <asm/pv/mm.h>
diff --git a/xen/arch/x86/x86_64/compat/entry.S b/xen/arch/x86/x86_64/compat/entry.S
index a99646c0cd4e..1e87652f4bcb 100644
--- a/xen/arch/x86/x86_64/compat/entry.S
+++ b/xen/arch/x86/x86_64/compat/entry.S
@@ -5,11 +5,11 @@
         .file "x86_64/compat/entry.S"
 
 #include <asm/asm_defns.h>
+#include <asm/irq-vectors.h>
 #include <asm/page.h>
 #include <asm/processor.h>
 #include <asm/desc.h>
 #include <public/xen.h>
-#include <irq_vectors.h>
 
 FUNC(entry_int82)
         ENDBR64
diff --git a/xen/arch/x86/x86_64/entry.S b/xen/arch/x86/x86_64/entry.S
index c5c723b5f4d4..40d094d5b2ee 100644
--- a/xen/arch/x86/x86_64/entry.S
+++ b/xen/arch/x86/x86_64/entry.S
@@ -7,10 +7,10 @@
         .file "x86_64/entry.S"
 
 #include <asm/asm_defns.h>
+#include <asm/irq-vectors.h>
 #include <asm/page.h>
 #include <asm/processor.h>
 #include <public/xen.h>
-#include <irq_vectors.h>
 
 /* %rsp: struct cpu_user_regs */
 .macro ASSERT_CONTEXT_IS_XEN